#!/usr/bin/perl -wT
##########################################################################
# search.pl - Stichwortsuche in einer WAIS Datenbank
##########################################################################

use CGI qw/:form :html param header/;
use Wais;

##########################################################################
# Konfiguration
##########################################################################
$htdocs_path = "/usr/local/etc/httpd/htdocs";
$dbname      = "website";
$hostname    = "m1";
$port        = 4711;
##########################################################################

print_form();                 # berschrift und Suchformular ausgeben

exit 0 unless param("query"); # Ohne spezifizierten Query ist hier Schlu

                              # Query ist angegeben, WAIS befragen
$result = Wais::Search({'query' => param("query"), 'database' => $dbname,
                        'host'  => $hostname,      'port'     => $port});

@results = $result->header(); # Ergebnisse aufbereiten

if($#results < 0) {           # Fehler aufgetreten?
    print pre(font({color=>"red"}, "Error - WAIS server down?\n"));
    return;
}

$nof_hits = $#results + 1;    # Anzahl der Ergebnisse
                              
if($nof_hits == 1) {          # Ein Ergebnis mit Score 0 => Kein Treffer
    my ($tag, $score) = @{$results[0]};
    $nof_hits = 0 unless $score;
}

print hr, i($nof_hits, " documents found\n"); # Anzahl Treffer

for(@results) {       # ber Ergebnisse iterieren

    my ($tag, $score, $lines, $bytes, $headline, $types, $docid) = @$_;

    next unless $score;       # Bogus-Ergebnis vergessen

                              # WAIS-Pfad in URL-Pfad umwandeln
    my ($file, $path) = split(' ', $headline);
    $path =~ s,^$htdocs_path/,,g;        # File-System-prefix wegwerfen
                              # URL in Tabelle hngen
    $rows .= TR(td( a({href=>"http://$hostname/$path$file"}, 
                      "$path$file")));
}

print table($rows);           # Tabelle ausgeben

##########################################################################
sub print_form {
##########################################################################

    print header, 
          start_html(-title   => 'Website Search',
                     -BGCOLOR => 'white'),
          center(h1("Search the Website")),
          center(table(TR(
              td(
                  p("Enter Query:")),
              td(
                  start_form,
                  textfield(-name  => 'query', 
                            -value => (param('query') || ""),
                            -size  => 40),
                  end_form,
          )))),
          end_html;
}

