#!/usr/bin/perl

$df_command = "/bin/df";    # df-Kommando listet File-Systeme

use CGI;
$q = CGI->new();            # CGI-Objekt

                           # 'die'-Anweisungen enden hier
$SIG{__DIE__} = sub { print $q->header; print $q->h1(@_); exit 0; };

# Plattenbelegung ber df-Kommando ermitteln
open(PIPE, "$df_command|") || die "$df_command: command not found";
while(<PIPE>) {
    $count++ || next;       # Erste Zeile ignorieren
    my ($drive, $total, $used, $free, $perc, $mount) = split(' ', $_);
    push(@mounts, $mount);
    push(@used, $used/1000);
    push(@free, $free/1000);
}
close(PIPE) || die "$df_command failed";

# Ohne Parameter aufgerufen - HTML-Seite ausgeben
if(!defined $q->param("graph")) {

    print $q->header, $q->start_html(-title => 'Chart Test');
    for (qw/bars stackedbars pie linespoints/) {
        print $q->img({src => "$ENV{SCRIPT_NAME}?graph=$_",
                       border => 3, 
                       hspace => 3,
                       vspace => 3}), "\n";
        print $q->br if $gcount++ % 2;
    }
    print $q->end_html;

} elsif($q->param("graph") eq "bars") {   # Balkengraphik

    use Chart::Bars;
    my $g = Chart::Bars->new(200,200);    # Objekt erzeugen
    $g->set('title' => 'Chart::Bars');    # Titel setzen
    $g->add_dataset(@mounts);             # Werte auf X-Achse
    $g->add_dataset(@free);               # Balkenhhe
    $g->cgi_gif();                        # Gif ausgeben

} elsif($q->param("graph") eq "stackedbars") {

    use Chart::StackedBars;
    my $g = Chart::StackedBars->new(200,200);
    $g->set ('title' => 'Chart::StackedBars');
    $g->set('x_label' => "File Systems");
    $g->set('y_label' => "Mega Bytes");
    $g->set('legend_labels' => ["free", "used"]);
    $g->set('grid_lines' => "true");
    $g->set('max_val' => 1500);
    $g->set('colors' => [[255,0,0], [0,255,0]]);
    $g->add_dataset(@mounts);
    $g->add_dataset(@used);
    $g->add_dataset(@free);
    $g->set('legend_labels' => ["free", "used"]);
    $g->cgi_gif();

} elsif($q->param("graph") eq "pie") {    # Kuchengraphik

    use Chart::Pie;
    my $g = Chart::Pie->new(200,200);     # Objekt erzeugen
    $g->set ('title' => 'Chart::Pie');    # Titel setzen
    $g->add_dataset("used","free");       # Anteil-Beschreibung
    $g->add_dataset($free[0],$used[0]);   # Werte-Satz
    $g->cgi_gif();                        # Gif ausgeben

                                          # Linien mit 
                                          # Sttzpunkten
} elsif($q->param("graph") eq "linespoints") {

    use Chart::LinesPoints;
    my $g = Chart::LinesPoints->new(200,200);
    $g->set ('title' => 'Chart::LinesPoints');
    $g->add_dataset(@mounts);             # X-Achsen-Werte
    $g->add_dataset(@used);               # Hhe
    $g->cgi_gif();                        # Gif ausgeben

                                          # Gestaffelte Balken
}

