#!/usr/bin/perl -w

use CGI qw/:standard :html/;
use Net::Telnet;

   # Konfiguration
$userid = "watch";
$passwd = "topsecret!";

    # Server-Namen und deren Prompts
@hosts = (['machine1.domain.com', 'machine1>'],
          ['machine2.domain.com', '$'],
          ['machine3.domain.com', '>'],
          ['murkshost', '$'],
         );
$logfilename = "/log/error_log";

    # Alle Rechner abklappern
for (@hosts) {
    my ($host, $prompt) = @$_;

    $prompt = sprintf('^%s\s*$', quotemeta($prompt));

    $telnet = new Net::Telnet (Host    => $host,
                               Timeout => 60,
                               Prompt  => "/$prompt/m");

        # Einloggen, 'die' abfangen
    eval { $telnet->login($userid, $passwd); };

    if($@) {    # Fehler aufgetreten?
        push(@hostinfo, [$host, "Login FAILED"]);
    } else {
                # Last abfragen
        @lines = $telnet->cmd("uptime");
        ($load) = ($lines[0] =~ /average:\s*([0-9.]+)/); 

                # Logfile-Lnge abfragen
        @lines = $telnet->cmd("ls -l $logfilename");
        $logsize = (split(' ', $lines[0]))[4];
        1 while ($logsize =~ s/^(\d+)(\d\d\d)/$1.$2/);

        push(@hostinfo, [$host, "OK", $load, $logsize]);
    }

    $telnet->close;
}

    # HTML ausgeben
cgiprint(start_html(-BGCOLOR => "bisque",
                    "title"  => "Watch your Servers!"));

    # berschrift
cgiprint(h1("Watch your Servers!"), "\n");

$tablecontent = TR( th("Host"), th("Status"), 
                    th("Load"), th("Logfile Size"), "\n" );

    # @hostinfo LoL -> HTML Tabelle 
foreach $lref (@hostinfo) {
    $tablecontent .= TR( map { td($_) } @$lref ) . "\n";
}

    # Tabelle ausgeben
cgiprint(table({border => 1}, $tablecontent));
cgiprint(end_html());


#########################################################
sub cgiprint {
#########################################################
# Text ausgeben, Header falls notwendig
#########################################################
    print header() unless defined $header_printed;
    print "@_";
    $header_printed = 1;
}

