#!/usr/bin/perl -w

use CGI qw/:standard :html3/;

$cudir         = "customers";  # Verzeichnis fr 
                              # temporre Dateien
$items_total   = 100;          # Gesamtzahl Artikel
$items_perpage = 10;           # Dargestellt pro Seite

foreach $i (1..$items_total) { # Pseudo-Artikel-Hash
    $merchandise{$i} = "Artikel Nummer $i";
}

$id = cookie(-name => 'ID');   # Cookie entgegennehmen

if(!defined $id) {             # Kein Cookie - neuer Kunde!
                               # Neue ID erzeugen
    $id = unpack ('H*', pack('Nc', time, $$ % 0xff));

                               # Adressformular schicken
    print header('-cookie' => cookie('ID' => $id));
    print_address_form();
    exit 0;
}

print header, start_html;

if(! -f "$cudir/$id") {
    save_cgi($q = new CGI);    # Neue Kundendatei anlegen
} else {                   
    $q = restore_cgi();        # Kundendatei einlesen
}
                               # Adressinformation komplett?
if(!$q->param('name') || !$q->param('vorname') ||
   !$q->param('strasse') || !$q->param('plz') || 
   !$q->param('wohnort')) {
    print_address_form("Bitte fllen Sie alle Felder aus.");
    exit 0;
}

$offset = ($q->param('offset') || 0);

@selected = grep { $_ <= $offset || 
                   $_ > $offset+$items_perpage } 
                 ($q->param('items'));

foreach $item (param('newitems')) {
    push(@selected, $item);
}

$q->delete('items');       # CGI-Parameter zurcksetzen
$q->param('items', @selected);
save_cgi($q);              # Neu gesetzt und gesichert

if(param('Bestellen')) {   # Ausgang
    print $q->param('vorname'), " ", $q->param('name'), br,
          $q->param('strasse'), br, 
          $q->param('plz'), " ", $q->param('wohnort'), 
          br, br, h1("Bestellung");
    foreach $item ($q->param('items')) {
        print "1 Stueck $merchandise{$item}", br;
    }
    print p, b("Ihre Bestellung ist schon unterwegs!"), end_html;

} else {                   # Warenliste anzeigen

    if($offset >= $items_perpage) {
        $offset -= $items_perpage if param("Zurckblttern");
    }
    if($offset < $items_total - $items_perpage) {
        $offset += $items_perpage if param("Vorblttern");
    }

    $q->param('offset', $offset);
    save_cgi($q);

    @subset = sort {$a <=> $b} keys %merchandise;
    @subset = splice(@subset, $offset, $items_perpage);

                           # Neue Warenliste
    print h1("Guten Tag, ", $q->param('vorname'), "!"),
          p, "Zur Auswahl stehen heute:",
          start_form(), 
          $q->checkbox_group(
              '-name'      => 'newitems',
              '-values'    => [@subset],
              '-default'   => [$q->param('items')],
              '-linebreak' => 'true',
              '-labels'    => \%merchandise),
          submit('Zurckblttern'), submit('Vorblttern'), 
          submit('Bestellen'), 
          end_form, end_html;
}

#############################################################
sub save_cgi {
#############################################################
    open(FILE, ">$cudir/$id") || die "Can't open $cudir/$id";
    $_[0]->save(FILE);
     close(FILE);
 }
 
 #############################################################
 sub restore_cgi {
 #############################################################
     die "Get off, hacker!" if $id !~ /^[0-9a-f]+$/;
     open(FILE, "<$cudir/$id") || die "Can't open $cudir/$id";
     my $q = new CGI(FILE);
     close(FILE);
     return $q;
 }
 
 #############################################################
 sub print_address_form {
 #############################################################
     my $msg = (shift || "");
     print start_html, 
           tt(CGI::font({color => 'red'}, $msg)),
           start_form, 
           table(
             TR(td("Name:"), td(textfield('name'))),
             TR(td("Vorname:"), td(textfield('vorname'))),
             TR(td("Strae:"), td(textfield('strasse'))),
             TR(td("Postleitzahl:"), td(textfield('plz'))),
             TR(td("Wohnort:"), td(textfield('wohnort')))),
           submit, end_form, end_html;
 }

