#!/usr/bin/perl -w
###################### Module ######################
use CGI qw/:standard :html3 -noDebug/;
use LWP::Simple qw/get getstore RC_OK/;
use HTML::TreeBuilder;             # HTML-Parser


################## Konfiguration ###################
$clipdir  = "/home/mschilli/clip";
$htmlfile = "clip.html";
                

################### Datei ffnen ###################
chdir($clipdir) || die "Cannot chdir to $clipdir";

open(OUT, ">$htmlfile") || 
    die "Cannot open $htmlfile";
                                   # Titel
print OUT start_html('-title' => "Clipping-Dienst");
print OUT dl;                      # Listenanfang


##### Kurznachrichten des Bayrischen Rundfunks #####
$ret = grab_and_grep(
           "http://www.br-online.de/news/aktuell", 
           "/<A NAME=\"1\".*<\\/TT>/s");

print OUT dt(h1("Bayrischer Rundfunk")), dd($ret);          


############ Erbeben-Karte der Bay-Area ############
$url = "http://quake.wr.usgs.gov/recenteqs" .
       "/Maps/SF_Bay.gif";
$localfile = "quake.gif";

print OUT dt(h1("Aktuelle Erbeben-Karte"));

if(getstore($url, $localfile) == RC_OK) {
    print OUT dd(img({src => "quake.gif"}));
} else {
    print OUT dd("Cannot get $url");
}


############### Dilbert Comic-Strip ################
$url = "http://www.unitedmedia.com/comics/dilbert/";
$localfile = "dilbert.gif";

print OUT dt(h1("Dilbert"));

if(dilbert_to_file($url, $localfile) == RC_OK) {
    print OUT dd(img({src => "dilbert.gif"}));
} else {
    print OUT dd("Cannot get $url");
}

##################### Abschlu #####################
print OUT end_html;
close(OUT);


####################################################
sub grab_and_grep {
####################################################
# Webseite holen und Text nach angegebenen 
# Muster extrahieren
####################################################
   my ($url, $regex) = @_;

   my $doc;

   ($doc = LWP::Simple::get $url) || 
       return "Cannot get $url";

   eval "\$doc =~ $regex; return \$&";
}

####################################################
sub dilbert_to_file {
####################################################
# Dilbert-Seite ($url) holen, Comic-URL extra-
# hieren, GIF holen und lokal in $file speichern
####################################################
   my ($url, $file) = @_;

   my ($doc, $abslink, $link);

   ($doc = get $url) || return 0;

   my $tree = HTML::TreeBuilder->new->parse($doc);

   for (@{$tree->extract_links(qw/img/)}) {
       $link = URI::URL->new($_->[0]);
       $abslink = $link->abs($url);
       last if $abslink =~ /dilbert\d+\.gif$/;
   }

   $tree->delete();           # Parse-Baum lschen

    getstore($abslink, $file); # Lokal speichern
 }

