#!/usr/bin/perl

use Date::Calc qw(Today Day_of_Week Decode_Month
                 Add_Delta_YMD Date_to_Days);

@days = qw/Mo Di Mi Do Fr Sa So/;

@today = Today();              # Heutiges Datum
$dow   = Day_of_Week(@today);  # Wochentag (Nummer)

foreach ($dow..$dow+6) {
    push(@result, [$days[$_ % 7], 0]);
}
                     # 'Fenster' fr Woche
@six_days_back = Add_Delta_YMD(@today, 0, 0, -6);
$window_from   = Date_to_Days(@six_days_back);
$window_to     = Date_to_Days(@today);

                     # Access-Log-Datei bearbeiten
open(LOGFILE, "<access.log") || 
    die "Cannot open file access.log";

while(<LOGFILE>) {   # Datum steht in [...] im
                     # Format dd/Mon/yyyy:hh:mm:ss
    if(m#\[(\d+)/(\w+)/(\d+)#) {
        ($day, $monthname, $year) = ($1, $2, $3);
        $month = Decode_Month($monthname);
        @date = ($year, $month, $day);
          
                     # Prfen, ob Datum in 
                     # letzter Woche liegt
        $days = Date_to_Days(@date);
        if($days >= $window_from && 
           $days <= $window_to) {
                     # Wochentag-Zhler erhhen
            $result[$days-$window_from]->[1]++; 
        }
    }
}
close(LOGFILE);

                     # Wochen-Report ausgeben
foreach $result (@result) {
    my ($weekday, $count) = @$result;
    printf "$weekday: %d\n", $count;
}

