#!/usr/bin/perl

use Tk;
use Proc::ProcessTable;

my $PTABLE = new Proc::ProcessTable;

# Hauptfenster
my $top = MainWindow->new();

# Widgets erzeugen: Listbox, 2 Buttons
$LISTBOX = $top->ScrlListbox(
    -background => "salmon",
    -label      => "Prozesse",
    -selectmode => "extended")->pack();
$refresh = $top->Button(
    -text       => "Refresh",
    -command    => \&fill_listbox)->pack();
$kill = $top->Button(
    -text       => "Kill",
    -command    => \&kill_selected)->pack();

# Listbox mit Prozessen fllen
fill_listbox($box, $ptable);

MainLoop;

##################################################
sub fill_listbox {   # Listbox aktualisieren
##################################################
    $LISTBOX->delete(0, "end");

    # Prozeliste durchgehen, Listbox fllen
    foreach $p (@{$PTABLE->table}) {
        $LISTBOX->insert("end",
            sprintf "%s %s", $p->pid, 
                    $p->cmndline || $p->fname);
    }
}

##################################################
sub kill_selected {  # Selektierte Prozesse killen
##################################################
    foreach $process ($LISTBOX->Getselected()) {
        ($pid) = ($process =~ /(\d+)/);
        kill("SIGTERM", $pid) ||
            print "Cannot kill PID $pid";
    }
}

