#!/usr/bin/perl -w
##################################################
# mschilli@perlmeister.com, 1999
# Run report on cookie tracker log file.
##################################################

open(DATA, "<track.dat") || die "Cannot open";

while(<DATA>) {

    # Format: date time stat ip id secs ver url ua
    my @fields      = split(' ', $_);
    my ($date, $stat, $id) = @fields[0,2,4];

    $dates{$date} = 1;

    if($stat eq "R" &&
       ! exists($id_seen_today{"$date$id"})) {
        $returns_per_date{$date}++;
    }
    $id_seen_today{"$date$id"} = 1;
}

foreach $date (sort keys %dates) {
    printf "$date> %4d\n", 
           $returns_per_date{$date} || 0;
}

close(DATA);

