#!/usr/bin/perl -w
##################################################
# mschilli@perlmeister.com, 1999
##################################################

use Logdata;
use CGI qw/:standard/;
use GIFgraph::pie;
use GIFgraph::bars;

my $NOF_DAYS = 30;
my $LOG_FILE = "track.dat";

if(!param('graph')) {
  print header, 
    start_html('-title' => "Cookie Statistik"),
    p("Die letzten $NOF_DAYS Tage ..."),          
    h1("Wiederkehrende Kunden"),
    img({src => self_url . "?graph=returns"}),
    h1("URLs pro Kunde"),
    img({src => self_url . "?graph=urls"}),
    h1("Benutzerverteilung ber aktive Tage"),
    img({src => self_url . "?graph=customers"}),
    ;
} else {
  print header(-type => "image/gif");
  my $log = Logdata->new($LOG_FILE, $NOF_DAYS) or
                   die "Cannot read logfile";

  if(param('graph') eq "returns") {
    my $TODAY    = time();
    my @wdays    = qw/So Mo Di Mi Do Fr Sa/;
    my @chkpts   = ();
    my $offset;

    foreach $offset (0..$NOF_DAYS-1) {
      my @L    = localtime $TODAY-$offset*24*3600;
      my $date = sprintf "%d/%02d/%02d", 
                       1900+$L[5], $L[4]+1, $L[3];
      unshift @chkpts, [$date, $wdays[$L[6]]];
    }
        
    my @days      = map { $_->[1] } @chkpts;
    my @returners = 
        map { scalar @{ $log->{odays}->{$_->[0]}} } 
            @chkpts;
        
    my $graph = GIFgraph::bars->new();
        
    $graph->set(x_label => 'Wochentage',
                y_label => 'Benutzer',
                'title' => '');
    print $graph->plot([\@days, \@returners] );

  } elsif(param('graph') eq "urls") {
    foreach $id (keys %{$log->{ids}}) {
        
      my %urls = ();
      $nofurls = grep { ! $urls{$_->{url}}++ }
                      @{$log->{ids}->{$id}};
        
      $users_with_n_urls{$nofurls}++;
    }
    foreach $n (keys %users_with_n_urls) {
      push(@xvals, $n);
      push(@yvals, $users_with_n_urls{$n});
    }

    my $graph = GIFgraph::pie->new();

    print $graph->plot([\@xvals, \@yvals] );

  } elsif(param('graph') eq "customers") {
    foreach my $id (keys %{$log->{ids}}) {
      my %uniq = ();
      my $nofudates = 
              scalar grep { ! $uniq{$_->{day}}++ } 
                          @{$log->{ids}->{$id}};
      $ids_per_udates{$nofudates}++;
    }

    foreach $udates (sort {$a <=> $b} 
                          keys %ids_per_udates) {
      push(@days, $udates);
      push(@customers, $ids_per_udates{$udates});
    }
    
    my $graph = GIFgraph::bars->new();
        
    $graph->set(x_label => 'Aktive Tage',
                y_label => 'Benutzer');
        
    print $graph->plot([\@days, \@customers] );
  }
}

