#!/usr/bin/perl -w

use CGI qw/:all/;
use HTML::Entities;
use HTML::FormatText;
use HTML::TreeBuilder;

$ENV{PATH}     = "/usr/bin";
my $BASE_DIR   = "/DATA/articles/glimpseindex";
my $LOCAL_TREE = "/DATA/articles/LOCAL_TREE";
my $HTTP_REP   = "http://";

print header();

print h1(center("Stichwortsuche in Perl-Artikeln")),
      h3("Schlsselwort(e) eingeben:"),
      start_form(), textfield(-name => "s"),
      submit(-name => "submit", -value => "Search"),
      end_form();

exit 0 unless param("s");

$count = 0;
$search = param("s");

    # Multiple search terms
$search =~ s/\s+/;/g unless $search =~ /"/;
    # Delete leading/trailing blanks, '," and \
$search =~ s/^\s+|\s+$|['"\\]//g;

$command = "glimpse -y -L 100 -i -W " .
           "-H $BASE_DIR '$search'";
    
open(PIPE, "$command |") or 
                   die "Cannot open $command";

while(<PIPE>) {
    my ($file, $text) = /(\S+):\s+(.*)/;
    $count++;
    $file =~ s#$LOCAL_TREE/#$HTTP_REP#g;
    $formatter = HTML::FormatText->new();
    $html = HTML::TreeBuilder->new->parse($text);
    $text = $formatter->format($html);
    $text = encode_entities($text);
    $result{$file} .= $text;
}

foreach $url (keys %result) {
    print li($result{$url}, 
          a({href => $url}, "Mehr")), p();
}

close(PIPE) || die "$command failed";

print ul(i("Nichts gefunden.")) unless $count;

