#!/usr/bin/perl -w
##################################################
# monitor.pl - 1999, mschilli@perlmeister.com
##################################################

use Curses;
use ProgressBar;    # Unser eigenes ProgressBar.pm
use LWP::Simple;

initscr;            # Curses initialisieren
keypad(1);          # Funny keys mappen
clear;              # Bildschirm lschen
noecho();           # Kein Tastenecho
nodelay(1);         # getch() soll nicht blocken
$SIG{__DIE__} =
$SIG{INT} = \&quit; # Aktion auf CTRL-C 

move(0,0);
addstr("My Cute Little Monitor v1.0");

while(1) {

        # Eventuell mehrere Tasten abfragen
    while ((my $key = getch()) ne ERR) {
        quit() if ($key eq 'q' || 
                   $key eq KEY_BACKSPACE);
    }

        # Abfragen starten
    print_update(1);
    plot_df("/", 2, 0);
    plot_df("/dos", 3, 0);
    plot_webhost("http://www.yahoo.com", 4, 0);
    plot_webhost("http://www.br-online.de", 5, 0);
    plot_webhost("http://www.amazon.com", 6, 0);
    print_update(0);

        # 10 Minuten auf Tastendruck warten
    $bitmap = '';
    vec($bitmap, fileno(STDIN), 1) = 1;
    select($bitmap, undef, undef, 600);
}

endwin;

##################################################
# Auslastung von Plattenpartition $partition auf
# Bildschirmkoordinaten $y/$x anzeigen
##################################################
sub plot_df {
    my ($partition, $y, $x) = @_;

    my $progress = ProgressBar->new(10);

    move($y, $x);
    addstr($partition);
    move($y, $x+30);
    addstr($progress->status(getdf($partition))); 
    refresh;
}

##################################################
# Host $host pingen und auf Terminalkoordinaten
# $y/$x anzeigen
##################################################
sub plot_webhost {
    my ($url, $y, $x) = @_;

    my ($dispurl) = ($url =~ m#//([^/]+)#);

    move($y, $x);
    addstr($dispurl);
    refresh;
    move($y, $x+30);
    addstr(pingurl($url) ? "Up  " : "Down");
    refresh;
}
    
##################################################
# Plattenauslasten fr Partition $part ermitteln
##################################################
sub getdf {
    my $part = shift;
    my $percentage;

    open PIPE, "/bin/df -k $part |" or 
         quit("Cannot run /bin/df");
    while(<PIPE>) {
         ($percentage) = /(\d+)%/;
    }
    close PIPE or quit("/bin/df failed");
    $percentage;
}

##################################################
# Bei $host anklopfen, 0=host down, 1=host up
##################################################
sub pingurl {
    my $url = shift;
 
     return(defined(get($url)));
 }
 
 ##################################################
 sub print_update {
 ##################################################
     my $on = shift;
 
     $msg = "Updating ...";
 
     standout() if $on;
     $msg = " " x length($msg) unless $on;
     addstr($LINES-1, $COLS - length($msg), $msg);
     standend() if $on;
     refresh();
 }
 
 ##################################################
 sub quit { 
 ##################################################
     print "@_\n";
     endwin(); 
     exit(0); 
 }

