#!/usr/bin/perl -w

use XmlUserAgent;
use HTTP::Cookies;

$ua  = XmlUserAgent->new();
$jar = HTTP::Cookies->new();

$ua->cookie_jar($jar);

foreach $xml (@ARGV) {
    open FILE, "<$xml" or die "Cannot open $xml";
    my $data = join '', <FILE>;
    close FILE;

    $response = $ua->request($data);

    {  # Handle POST redirects
       if($response->code == 302) {
           $request = HTTP::Request->new(GET => 
                   $response->header('Location'));    
           $response = $ua->request($request);
           redo;
       }
    }
}

if ($response->is_success) {
    print $response->headers_as_string(), "\n",
          $response->content(), "\n\n";
} else {
    print "Error! Code=", $response->code, "\n";
    print "Message=", $response->message, "\n\n";
}

